



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Docker搭建MySQL服务</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Docker搭建MySQL服务</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-24 09:31:07 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<h1>Docker开源镜像</h1>
<p>前面我们已经安装好了Docker，也简单了解了Docker。那么我们可以尝试搭建一个MySQL服务。</p>
<p>要搭建服务就要启动服务容器，要创建容易就要有镜像，Docker提供了一个类似Github的开源平台，提供开源镜像，放心可靠。（毕竟大家都看着源码呢）</p>
<p><a href="https://hub.docker.com/" rel="external nofollow noreferrer">Docker开源镜像传送门</a></p>
<hr />
<h1>大概步骤</h1>
<p><strong>1. 下载MySQL镜像</strong> <br />
<strong>2. 创建运行容器</strong></p>
<blockquote><p>好像很简单是吧？</p></blockquote>
<hr />
<h1>详细步骤</h1>
<h2>第零步，查看Docker MySQL文档</h2>
<p>MySQL文档地址： <br />
<a href="https://hub.docker.com/_/mysql/" rel="external nofollow noreferrer">https://hub.docker.com/_/mysql/</a></p>
<hr />
<h2>第一步，拉取MySQL镜像</h2>
<pre class="prettyprint linenums"><code>$ sudo docker pull mysql</code></pre>
<p>之后docker会自动拉取（下载）MySQL镜像。</p>
<p>等待同样是漫长的。。。</p>
<blockquote><p>注意，若提示拉取失败就重复几次，总有一次会成功的。。。没办法，墙内的人民很辛苦</p></blockquote>
<p>拉取成功后我们查看一下：</p>
<pre class="prettyprint linenums"><code>$ sudo docker images</code></pre>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160317140105707" /></p>
<hr />
<h2>第二步，创建并启动一个MySQL容器</h2>
<p>输入以下命令：</p>
<pre class="prettyprint linenums"><code>$ sudo docker run --name pwc-mysql -e MYSQL_ROOT_PASSWORD=123456 -p 3306:3306 -d mysql</code></pre>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160317142223778" /></p>
<ul><li>&ndash;name：给新创建的容器命名，此处命名为<code>pwc-mysql</code></li>
<li>-e：配置信息，此处配置<code>mysql</code>的<code>root用户</code>的登陆密码</li>
<li>-p：端口映射，此处映射<code>主机3306端口</code>到<code>容器pwc-mysql的3306端口</code></li>
<li>-d：成功启动容器后输出容器的完整ID，例如上图 <code>73f8811f669ee...</code></li>
<li>最后一个<code>mysql</code>指的是<code>mysql镜像名字</code></li></ul>
<p><strong>到这里我们查看容器运行状态：</strong></p>
<pre class="prettyprint linenums"><code>$ sudo docker ps</code></pre>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160317142325183" /></p>
<p>上图可以看到容器的简写ID，容器的源镜像，创建时间，状态，端口映射信息，容器名字等。</p>
<hr />
<h2>第三步，测试连接MySQL</h2>
<p>这里我使用navicat远程连接，连接MySQL前需要防火墙开放端口或者关闭防火墙。</p>
<p>开放端口：</p>
<pre class="prettyprint linenums"><code>$ sudo firewall-cmd --add-port=3306/tcp</code></pre>
<p>关闭防火墙：</p>
<pre class="prettyprint linenums"><code>$ sudo systemctl stop firewalld</code></pre>
<p>接着使用navicat连接 <br />
<img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160317143333986" /></p>
<p>连接成功，也可以进行相关数据库操作，因此MySQL服务搭建成功！</p>
<hr />
<h1>其他</h1>
<p><strong>1.可以启动多个MySQL服务，因为我们启动的是容器，容器可以有多个，只要容器名字映射段端口不一样就可以了，例如：</strong></p>
<pre class="prettyprint linenums"><code>$ sudo docker run --name dbdb -e MYSQL_ROOT_PASSWORD=123456 -p 6666:3306 -d mysql</code></pre>
<p><strong>2.查看所有容器（启动状态或者关闭状态）</strong></p>
<pre class="prettyprint linenums"><code>$ sudo docker ps -a</code></pre>
<p><strong>3.启动和关闭容器</strong></p>
<p>启动命令：</p>
<pre class="prettyprint linenums"><code>$ sudo docker start pwc-mysql   //通过指定容器名字<br />
$ sudo docker start 73f8811f669e  //通过指定容器ID</code></pre>
<p>关闭命令：</p>
<pre class="prettyprint linenums"><code>$ sudo docker stop pwc-mysql   //通过指定容器名字<br />
$ sudo docker stop 73f8811f669e  //通过指定容器ID</code></pre>
<p><strong>3.修改MySQL配置文件有两种方法：</strong></p>
<ul><li><p>一是进入容器，修改容器里的MySQL的配置文件，然后重新启动容器，例如：</p>
<pre class="prettyprint linenums"><code>$ sudo docker exec -it pwc-mysql /usr/bin/bash</code></pre>
<p>然后可以进入容器的命令行模式，接着修改 <code>/etc/mysql/my.cnf</code> 文件即可</p></li>
<li><p>二是挂载主机的mysql配置文件，官方文档如下：</p>
<p>The MySQL startup configuration is specified in the file <code>/etc/mysql/my.cnf</code>, and that file in turn includes any files found in the <code>/etc/mysql/conf.d</code> directory that end with .cnf. Settings in files in this directory will augment and/or override settings in <code>/etc/mysql/my.cnf</code>. If you want to use a customized MySQL configuration, you can create your alternative configuration file in a directory on the host machine and then mount that directory location as <code>/etc/mysql/conf.d</code> inside the mysql container.</p>
<p>If <code>/my/custom/config-file.cnf</code> is the path and name of your custom configuration file, you can start your mysql container like this (note that only the directory path of the custom config file is used in this command):</p>
<pre class="prettyprint linenums"><code>$ docker run --name some-mysql -v /my/custom:/etc/mysql/conf.d -e MYSQL_ROOT_PASSWORD=my-secret-pw -d mysql:tag</code></pre>
<p>This will start a new container some-mysql where the MySQL instance uses the combined startup settings from <code>/etc/mysql/my.cnf</code> and <code>/etc/mysql/conf.d/config-file.cnf</code>, with settings from the latter taking precedence.</p></li></ul>
<p><strong>我大概可以看懂，相信大家都可以的</strong></p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq421e9z.html">JavaScript的闭包</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1r5348.html">SQL Server 2000向SQL Server 2008 R2推送数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/390d1jj8.html">问题：QXcbConnection&colon; Could not connect to display</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8ze7r38.html">java&period;lang&period;IncompatibleClassChangeError&colon; Implementing class的解决办法&comma;折腾了一天总算解决了</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1e7m09.html">php中count获取多维数组长度的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvvw3yq.html">Merge Sorted Array &lbrack;LeetCode&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd2zpgq.html">基础组件&lowbar;Window（窗口）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1o2ze9.html">【网络收集】如何修改vs tfs的登录名和密码 &period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdnx138.html">php parallel</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1ee4x9.html">ORACLE DATAGURARD配置手记</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdm5m78.html">MyBatis 学习入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1znndz9.html">&lbrack;JavaScript&rsqb; js实现简单的代码运行框</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj4omz9.html">在SPItemEventReceiver中使用BeforeProperties和AfterProperties</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydmvwmq.html">&lbrack;C&plus;&plus;程序设计&rsqb;指针总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jk4lw8.html">js--事件对象的理解3</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey025j9.html">【dp】 poj 1157</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj5g1r8.html">JS可维护性代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg14dm8.html">CTF中怎看phpinfo</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdprddjq.html">Java集合框架体系详细梳理，含面试知识点。</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj3kx09.html">java开发中几种常见的线程池</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9j0m55wq.html">微软职位内部推荐-Senior Development Lead</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvexyxq.html">TF-IDF与余弦相似性的应用（二）：找出相似文章</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1owwj9.html">或许你不知道：ArrayList</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1mpwe9.html">android 开发 解码gif图片，获取每帧bitmap</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zvg729.html">timersmanager 解析</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wk74oq.html">JavaScript 变量、作用域和内存问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vdvgj8.html">【POJ】【1635】Subway Tree Systems</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1mppj9.html">java 邮箱验证公共方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xjyl09.html">Core Data 版本数据迁移</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnld508.html">引擎设计跟踪&lpar;九&period;14&period;2i&rpar; Android GLES 3&period;0 完善</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
